// pbinfo
#include <iostream>
using namespace std;

/* 
    Funcția LCA determină cel mai mic strămos comun (LCA) dintre doua noduri x și y 
    si returneaza numărul de muchii dintre u și v.
*/

int LCA (int x, int y)
{
	int sol = 0;   // numarul total de muchii dintre u și v
	
	while (x != y)    // cat timp nodurile nu sunt identice
	{ 		
		if (y < x)     // Dacă y este mai mic decat x, le inversam
			swap(x, y);
		y = y / 2;    // mergem la parintele nodului y
		++sol;        // incrementam numărul de muchii
	}
	
	return sol; 
}

int main()
{
	ios_base::sync_with_stdio(false); // Optimizări - desincronizarea buffer-elor lui cin si cout
	cin.tie(nullptr); cout.tie(nullptr);
	
	int q, x, y;
	cin >> q; 
	while (q--)
	{
		cin >> x >> y; 
		cout << LCA(x, y) << '\n';
	}
	
}
