#include <fstream>

using namespace std;

ifstream fin("stramosi.in");
ofstream fout("stramosi.out");

const int MAX_N = 250000;

int n, m;;
int lg2[MAX_N + 5], stramos[18][MAX_N + 5];
/// stramos[i][j] al 2^i lea stramos al lui j

int main ()
{
    fin >> n >> m;
    for (int i = 1; i <= n; i++)
        fin >> stramos[0][i];

    lg2[0] = lg2[1] = 0;
	for (int i = 2; i <= n; i++)
		lg2[i] = lg2[(i >> 1)] + 1;

	/// sau lg2 = log2(n), sau (1 << i) <= n
	for (int i = 1; i <= lg2[n]; i++)
		for(int j = 1; j <= n; j++)
			stramos[i][j] = stramos[i - 1][stramos[i - 1][j]];

	int nod, p, i;
    while (m--)
    {
        fin >> nod >> p;

        i = 0;
        while (p)  /// p = 101101 = 2^5 + 2^3 + 2^2 + 1^0
        {
            if (p & 1)
                nod = stramos[i][nod];
			i++;
            p >>= 1;
        }

        fout << nod << '\n';
    }
    return 0;
}
